package org.daisy.dotify.impl.input;

/**
 * Provides a set of keys commonly used within this bundle.
 * @author Joel Håkansson
 */
public class Keys {

	/**
	 * Provides a format name for pef files
	 */
	public static final String PEF_FORMAT = "pef";
	/**
	 * Provides a format name for text files
	 */
	public static final String TEXT_FORMAT = "text";
	/**
	 * Provides a format name for obfl files
	 */
	public static final String OBFL_FORMAT = "obfl";
	/**
	 * Defines a key for the input file
	 */
	public static final String INPUT = "input";
	/**
	 * Defines a key for input format
	 */
	public static final String INPUT_FORMAT = "inputFormat";
	/**
	 * Defines a key for input uri
	 */
	public static final String INPUT_URI = "input-uri";
	/**
	 * Defines a key for template
	 */
	public static final String TEMPLATE = "template";
	/**
	 * Defines a key for temp files directory
	 */
	public static final String TEMP_FILES_DIRECTORY = "tempFilesDirectory";

	private Keys() {}
}
