<?xml version="1.0" encoding="utf-8"?>
<!--
	DTBook to Flow for text (sv_SE)

	Description
	DTBook to Flow stylesheet for Swedish text only.

	Parameters
		page-width (inherited)
		page-height (inherited)
		inner-margin (inherited)
		outer-margin (inherited)
		row-spacing (inherited)
		duplex (inherited)
		hyphenate (inherited)

	Format (input -> output)
		DTBook -> Flow

	Author: Joel Håkansson
-->
<!--
	TODO:
		- komplexa sub, sup
		- länkar, e-postadresser
-->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:dtb="http://www.daisy.org/z3986/2005/dtbook/" exclude-result-prefixes="dtb" xmlns="http://www.daisy.org/ns/2011/obfl">

	<xsl:import href="dtbook2obfl_layout.xsl" />
	<xsl:output method="xml" encoding="utf-8" indent="no"/>
	<xsl:template name="insertLayoutMaster">
		<layout-master name="front" page-width="{$page-width}" 
							page-height="{$page-height}" inner-margin="{$inner-margin}"
							outer-margin="{$outer-margin}" row-spacing="{$row-spacing}" duplex="{$duplex}">
			<default-template>
				<header></header>
				<footer></footer>
			</default-template>
		</layout-master>
		<layout-master name="main" page-width="{$page-width}" 
							page-height="{$page-height}" inner-margin="{$inner-margin}"
							outer-margin="{$outer-margin}" row-spacing="{$row-spacing}" duplex="{$duplex}">
			<default-template>
				<header></header>
				<footer></footer>
			</default-template>
		</layout-master>
		<layout-master name="plain" page-width="{$page-width}" 
							page-height="{$page-height}" inner-margin="{$inner-margin}"
							outer-margin="{$outer-margin}" row-spacing="{$row-spacing}" duplex="{$duplex}">
			<default-template>
				<header></header>
				<footer></footer>
			</default-template>
		</layout-master>
	</xsl:template>

	<xsl:template match="dtb:doctitle[parent::dtb:frontmatter] | dtb:docauthor[parent::dtb:frontmatter]" priority="20">
		<block><xsl:apply-templates/></block>
	</xsl:template>

</xsl:stylesheet>
