package org.daisy.dotify.translator;

/**
 * Provides a common set of marker dictionary identifiers.
 * The purpose is to provide a set of identifiers that most implementations
 * support.
 * 
 * @author Joel Håkansson
 */
public interface MarkerStyleConstants {

	/**
	 * Defines strong style.
	 */
	public static final String STRONG = "strong";
	/**
	 * Defines emphasis style.
	 */
	public static final String EM = "em";
	/**
	 * Defines subscript style.
	 */
	public static final String SUB = "sub";
	/**
	 * Defines superscript style.
	 */
	public static final String SUP = "sup";
	/**
	 * Defines a definition description style.
	 */
	public static final String DD = "dd";

}
